package pwc.taxtech.atms.vat.service.impl.report.functions;

import org.apache.poi.ss.formula.OperationEvaluationContext;
import org.apache.poi.ss.formula.eval.EvaluationException;
import org.apache.poi.ss.formula.eval.NumberEval;
import org.apache.poi.ss.formula.eval.ValueEval;
import org.apache.poi.ss.formula.functions.FreeRefFunction;
import pwc.taxtech.atms.dto.OperationResultDto;
import pwc.taxtech.atms.dto.TableRule;
import pwc.taxtech.atms.exception.Exceptions;

import java.util.HashMap;
import java.util.Map;

import static pwc.taxtech.atms.common.util.FormulaUtil.resolverInteger;
import static pwc.taxtech.atms.common.util.FormulaUtil.resolverString;

/**
 * @ClassName TABLESUMIF
 * Description TODO
 * @Author pwc kevin
 * @Date 3/11/2019 2:52 PM
 * Version 1.0
 **/
public class TABLESUMIF extends FunctionBase implements FreeRefFunction {

    private String  tableName;
    public TABLESUMIF(FormulaContext formulaContext) {
        super(formulaContext);
    }

    //进行参数验证
    public void parameterCheck(ValueEval[] args, OperationEvaluationContext ec) {
        argsLength = args.length;
        if (argsLength != 6) //参数小于当做异常处理， 最后俩参数可以取默认值
            throw Exceptions.parameterError;
        try {
            tableName = resolverString(args, ec, 0);
            Map<String, String> map = TableRule.map;
            if (!map.containsKey(tableName))
                throw Exceptions.parameterError;
        } catch (EvaluationException e) {
            e.printStackTrace();
        }

    }

    Integer argsLength;

    String getField;
    Integer period;
    String year;

    @Override
    public ValueEval evaluate(ValueEval[] args, OperationEvaluationContext ec) {
        parameterCheck(args, ec);
        try {
            tableName = resolverString(args, ec, 0);
            getField = resolverString(args, ec, 1);
            String filter = resolverString(args, ec, 2);
            String filterValue =resolverString(args, ec, 3);
            period = resolverInteger(args, ec, 4);//会计期间
            year = resolverString(args, ec, 5);//会计年度
            new  NumberEval(agent.getTableDataByName(tableName, getField,filter,filterValue, period, year, formulaContext));
        } catch (EvaluationException e) {
            e.printStackTrace();
            return  new NumberEval(0.00);
        }

        return  new NumberEval(0.00);
    }
}
