/**
 * Created by Administrator on 2019/3/1 0001.
 */
taxDocumentManageModule.controller('taxDocumentListController',
    ['$log', '$http', '$q', '$scope', '$translate', '$timeout', 'SweetAlert', '$compile', 'taxDocumentListService', '$filter','apiInterceptor',
        function ($log, $http, $q, $scope, $translate, $timeout, SweetAlert, $compile, taxDocumentListService, $filter,apiInterceptor) {

            $scope.queryFieldModel = {};
            $scope.editFieldModel = {
            };
            $scope.resetQueryField = function(){
                $scope.queryFieldModel={};

                $("#period-picker1").val("");
                $("#period-picker2").val("");
                $("#period-picker3").val("");
                $("#period-picker4").val("");
            };

            $scope.pagingOptions = {
                pageIndex: 1,  //当前页码
                totalItems: 0,  //总数据
                pageSize: 10,  //每页多少条数据
                pageSizeString: '10',
            };
            $scope.localData = null;
            $scope.loadMainData = function () {

                $scope.queryFieldModel.currentPage = $scope.pagingOptions.pageIndex;
                $scope.queryFieldModel.pageSize = $scope.pagingOptions.pageSize;
                taxDocumentListService.fetchMainList($scope.queryFieldModel).then(function (data, status, headers) {
                    if (status === 204) {
                        SweetAlert.warning($translate.instant("NoData"));
                        return;
                    }
                    // console.log("taxDocList:", data);
                    $scope.dataGridUpdate(data);

                })
            };
            $scope.dataGridUpdate = function (_data) {
                $scope.localData = _data.list;
                $scope.pagingOptions.pageIndex = _data.pageNo;
                $scope.pagingOptions.totalItems = _data.total;
                $scope.dataGridOptions = {
                    bindingOptions: {
                        dataSource: 'localData',
                    },
                    showBorders: true,
                    sorting: {//排序
                        ascendingText: "Sort Ascending",
                        clearText: "Clear Sorting",
                        descendingText: "Sort Descending",
                        mode: "single"
                    },
                    'export': {
                        allowExportSelectedData: false,//允许选择导出
                        customizeExcelCell: null,
                        enabled: true,//允许导出
                        excelFilterEnabled: false,
                        excelWrapTextEnabled: false,
                        fileName: "taxDocList",//名字
                        ignoreExcelErrors: true,

                    },
                    showRowLines: true,
                    columnAutoWidth: true,
                    allowColumnReordering: true,
                    columns: [
                        {
                            dataField: "id",
                            caption: "",
                            cellTemplate: function (container, options) {
                                $('<input name="dataGridCheckBox" type="checkbox">').appendTo(container);
                            }
                        },
                        {
                            dataField: "fileAttr",
                            caption: $translate.instant('DocumentAttr'),

                        },
                        {
                            dataField: "fileType",
                            caption: $translate.instant('DocumentType'),

                        },
                        {
                            dataField: "fileName",
                            caption: $translate.instant('DocumentName'),

                        },

                        {
                            dataField: "businessLine",
                            caption: $translate.instant('BusinessLine'),

                        },

                        {
                            dataField: "companyName",
                            caption: $translate.instant('CorporationName'),

                        },
                        {
                            dataField: "taxType",
                            caption: $translate.instant('TaxType'),
                        },
                        {
                            dataField: "fileTime",
                            caption: $translate.instant('AvailabilityDate'),

                            cellTemplate: function (container, options) {
                                try {
                                    if (options.data.fileTime) {
                                        $('<span>').text($filter('date')(options.data.createTime, 'yyyy-MM-dd')).appendTo(container);
                                    } else {
                                        $('<span>').text('').appendTo(container);
                                    }
                                } catch (e) {
                                    $log.error(e);
                                }
                            }
                        },
                        {
                            dataField: "ownTime",
                            caption: $translate.instant('Duration'),
                            cellTemplate: function (container, options) {
                                try {
                                    if (options.data.ownTime) {
                                        $('<span>').text($filter('date')(options.data.createTime, 'yyyy-MM-dd')).appendTo(container);
                                    } else {
                                        $('<span>').text('').appendTo(container);
                                    }
                                } catch (e) {
                                    $log.error(e);
                                }
                            }
                        },
                        {
                            dataField: "effectiveTime",
                            caption: $translate.instant('DueDate'),

                            cellTemplate: function (container, options) {
                                try {
                                    if (options.data.effectiveTime) {
                                        $('<span>').text($filter('date')(options.data.createTime, 'yyyy-MM-dd')).appendTo(container);
                                    } else {
                                        $('<span>').text('').appendTo(container);
                                    }
                                } catch (e) {
                                    $log.error(e);
                                }
                            }
                        },
                        {
                            dataField: "auditStatus",
                            caption: $translate.instant('ApprovalStatus'),

                        },
                        {
                            dataField: "physicalIndexNumber",
                            caption: $translate.instant('EntityIndex'),

                        },
                        {
                            dataField: "storageArea",
                            caption: $translate.instant('EntityStorageLocation'),

                        },
                        {
                            dataField: "keeper",
                            caption: $translate.instant('EntityCustodian'),

                        },
                        {
                            dataField: "uploadTime",
                            caption: $translate.instant('UploadDate'),
                            cellTemplate: function (container, options) {
                                try {
                                    if (options.data.uploadTime) {
                                        $('<span>').text($filter('date')(options.data.createTime, 'yyyy-MM-dd')).appendTo(container);
                                    } else {
                                        $('<span>').text('').appendTo(container);
                                    }
                                } catch (e) {
                                    $log.error(e);
                                }
                            }

                        },
                        {
                            dataField: "creator",
                            caption: $translate.instant('Creator'),

                        },
                        {
                            dataField: "remark",
                            caption: $translate.instant('Remarks'),

                        },
                        {
                            dataField: "",
                            caption: $translate.instant('Operation'),

                            cellTemplate: function (container, options) {

                                var prevTargetString = '<a style="color:#506bf7;margin-right:1rem;" href="javascript:void(0)" ng-click="viewRemoteFile(\''
                                    + options.data.fileName + '\',\'' + options.data.filePositionUrl
                                    + '\')">'
                                    + '<span>{{"Preview"|translate}}</span></a>';
                                var editTargetString = '<a style="color:#506bf7;" href="javascript:void(0)" ng-click="openSimpleUploadPop(\''
                                    + options.data.id
                                    + '\')">'
                                    + '<span>{{"Edit"|translate}}</span></a>';
                                var eventTarget = $(prevTargetString + editTargetString);
                                $compile(eventTarget)($scope);
                                container.append(eventTarget);
                            }

                        },
                    ],
                };
            };

            //弹出框
            $scope.isCreatePop = false;
            var openSimpleUploadPop = function (rowId) {
                $scope.uploader.clearQueue();
                // 带ID的就是编辑窗口
                if (rowId) {
                    $scope.isCreatePop = false;
                    $scope.simpleUploadSubmit = editDocFileRecord;
                    $scope.localData.forEach(function (item) {
                        if (item.id == rowId) {
                            $scope.editFieldModel = angular.copy(item);
                            $scope.editFieldModel.ownTime = dateFormat(item.ownTime);
                            $scope.editFieldModel.fileTime = dateFormat(item.fileTime);
                            $scope.editFieldModel.effectiveTime = dateFormat(item.effectiveTime);

                            function dateFormat(date){
                                if(!date)return "";
                                var _date = new Date(date);
                                var yy = _date.getFullYear();
                                var mm = _date.getMonth() + 1;
                                var dd = _date.getDate();
                                return yy + "-" + mm + "-" + dd;
                            }
                        }
                    });
                }
                else {
                    $scope.isCreatePop = true;
                    $scope.simpleUploadSubmit = simpleUploadSubmit;
                    $scope.editFieldModel = {};
                }

                $('#simpleUploadPopDialog').modal('show');
            };

            $scope.isCoverOperation = false;
            //新建档案
            var simpleUploadSubmit = function () {

                taxDocumentListService.verifyDuplicate($scope.editFieldModel).then(function(data){

                    // 先设置上传参数
                    var uploadItem = $scope.uploader.queue[0];
                    var fileName = uploadItem._file ? uploadItem._file.name : uploadItem.name;
                    uploadItem.formData = [
                        {originFileName:fileName},
                    ];
                    Object.keys($scope.editFieldModel).forEach(function(key){
                        var fields = {};
                        if(/(ownTime|fileTime|effectiveTime)/.test(key)){
                            fields[key] = $scope.editFieldModel[key].split("-").join("/");
                        }else{
                            fields[key] = $scope.editFieldModel[key];
                        }
                        uploadItem.formData.push(fields);
                    });

                    // data == true,代表可以直接上传，否则属于覆盖行为
                    if (data === true) {
                        $scope.uploader.url = apiInterceptor.webApiHostUrl + "/taxDoc/add";
                        $scope.uploader.uploadItem(0);
                        $scope.isCoverOperation = false;

                        // $('#busy-indicator-container').show();
                        // addLogicAfterUploadFile($scope.editFieldModel,'simple');
                    } else {
                        SweetAlert.swal({
                                title: '提示',
                                text: $translate.instant("CoverConfirm"),
                                type: "warning",
                                showCancelButton: true,
                                confirmButtonColor: "#DD6B55",
                                confirmButtonText: $translate.instant('Confirm'),
                                cancelButtonText: $translate.instant('Cancel'),
                                closeOnConfirm: true,
                                closeOnCancel: true
                            },
                            function (isConfirm) {
                                if (isConfirm) {
                                    $scope.uploader.url = apiInterceptor.webApiHostUrl + "/taxDoc/edit";
                                    $scope.uploader.uploadItem(0);
                                    // editDocFileRecord($scope.editFieldModel, 'simple');

                                    // $('#busy-indicator-container').show();
                                    $scope.isCoverOperation = true;
                                }
                            })
                    }
                });
            };

            var addLogicAfterUploadFile = function(editFieldModel,type){

                taxDocumentListService.addNewRecord(editFieldModel).then(function (data) {
                    if (data === true) {
                        if(type === 'simp'){
                            SweetAlert.swal({
                                    title:$translate.instant("Created"),
                                    type: "success",
                                    confirmButtonText: $translate.instant('Confirm'),
                                    closeOnConfirm: true
                                },
                                function (isConfirm) {
                                    if(isConfirm) $scope.loadMainData();
                                });
                        }else{
                            if($scope.multiUploadSuccessItems.length === 0){
                                SweetAlert.swal({
                                        title:$translate.instant("Uploaded"),
                                        type: "success",
                                        confirmButtonText: $translate.instant('Confirm'),
                                        closeOnConfirm: true
                                    },
                                    function (isConfirm) {
                                        if(isConfirm) $scope.loadMainData();
                                    });
                            }
                        }
                    } else {
                        SweetAlert.warning($translate.instant('SaveFail'));
                    }
                    $('#simpleUploadPopDialog').modal('hide');
                    $('#multiUploadPopDialog').modal('hide');
                });
            };

            var editDocFileRecord = function (fieldModel,type) {

                taxDocumentListService.editRecord(fieldModel).then(function (data) {
                    if (data === true) {
                        if(type === 'simple'){
                            SweetAlert.swal({
                                    title:$translate.instant("Edited"),
                                    type: "success",
                                    confirmButtonText: $translate.instant('Confirm'),
                                    closeOnConfirm: true
                                },
                                function (isConfirm) {
                                    if(isConfirm) $scope.loadMainData();
                                });
                        }else{
                            if($scope.multiUploadSuccessItems.length === 0){
                                SweetAlert.swal({
                                        title:$translate.instant("Uploaded"),
                                        type: "success",
                                        confirmButtonText: $translate.instant('Confirm'),
                                        closeOnConfirm: true
                                    },
                                    function (isConfirm) {
                                        if(isConfirm) $scope.loadMainData();
                                    });
                            }
                        }
                    } else {
                        SweetAlert.warning($translate.instant('SaveFail'));
                    }
                });
                $('#simpleUploadPopDialog').modal('hide');
                $('#multiUploadPopDialog').modal('hide');
            };

            //取消
            var cancelDocFileType = function () {
                console.log("cancelDocFileType")
            };

            var delRecord = function(){
                var delItems = {};
                delItems.ids=[];

                $("input[name='dataGridCheckBox']").each(function(index,item){
                    if(item.checked){
                        delItems.ids.push($scope.localData[index].id);
                    }
                });
                taxDocumentListService.delFileRecordItems(delItems).then(function(data){
                    if(data){
                        SweetAlert.swal({
                                title:$translate.instant("Deleted"),
                                type: "success",
                                confirmButtonText: $translate.instant('Confirm'),
                                closeOnConfirm: true
                            },
                            function (isConfirm) {
                                if(isConfirm) $scope.loadMainData();
                            });
                    }
                });
            };

            var downloadAttachment = function(){
                var checkedURLs = [
                    // 'http://47.94.233.173:11007/static/erp_tax_system/3221D133-85B8-4E22-AE9B-DBEBD942D217?expire=1552361736&signiture=_Wz1_8Z6T8h5qnZAGpoRa8kNZeqmE7KoztKeehzYK4U=',
                    // 'http://47.94.233.173:11007/static/erp_tax_system/3221D133-85B8-4E22-AE9B-DBEBD942D217?expire=1552361736&signiture=_Wz1_8Z6T8h5qnZAGpoRa8kNZeqmE7KoztKeehzYK4U=',
                    // 'http://47.94.233.173:11007/static/erp_tax_system/3221D133-85B8-4E22-AE9B-DBEBD942D217?expire=1552361736&signiture=_Wz1_8Z6T8h5qnZAGpoRa8kNZeqmE7KoztKeehzYK4U=',
                    // 'http://47.94.233.173:11007/static/erp_tax_system/3221D133-85B8-4E22-AE9B-DBEBD942D217?expire=1552361736&signiture=_Wz1_8Z6T8h5qnZAGpoRa8kNZeqmE7KoztKeehzYK4U=',
                ];
                $("input[name='dataGridCheckBox']").each(function(index,item){
                    if(item.checked){
                        checkedURLs.push($scope.localData[index].filePositionUrl);
                    }
                });
                if(!checkedURLs.length) return SweetAlert.warning($translate.instant("NeedChecked"));
                var triggerDelay = 100;
                var removeDelay = 1000;
                checkedURLs.forEach(function(item,index){
                    _createIFrame(item, index * triggerDelay, removeDelay);
                });
                function _createIFrame(url, _triggerDelay, _removeDelay) {
                    setTimeout(function() {
                        var frame = $('<iframe style="display: none;" class="multi-download"></iframe>');
                        frame.attr('src', url);
                        document.body.appendChild(frame[0]);
                        setTimeout(function() {
                            frame.remove();
                        }, _removeDelay);
                    }, _triggerDelay);
                }
            };

            $scope.loadSelectMap = function(){
                taxDocumentListService.getFileInfoOptions().then(function(data){
                    // console.log(data);
                    if(data){
                        Object.keys(data).forEach(function (item) {
                            $scope.fileTypeOptions[item] = item;
                        });
                        Object.values(data).forEach(function (item) {
                            $scope.fileAttrOptions[item] = item;
                        });
                    }

                });
                taxDocumentListService.getCompanyNameOptions().then(function(res){
                    if (res && 0 === res.code) {
                        angular.forEach(res.data, function (item) {
                            $scope.companyNameOptionsMap[item.id]=item.name;
                        });
                    } else {
                        SweetAlert.error($translate.instant('RevenueGetOrgError'));
                    }

                });
            };

            //----------------------taxation----basic-end-------------------------------

            (function initialize() {
                $scope.fileTypeOptions = {};
                $scope.fileAttrOptions = {};
                $scope.companyNameOptionsMap = {};
                $scope.editFieldModel = {};
                $scope.editFieldModel_multi = [];
                $scope.uploader = {};
                $scope.multiUploader = {};
                $scope.loadMainData();
                $scope.loadSelectMap();
                //注册方法
                $scope.openSimpleUploadPop = openSimpleUploadPop;
                $scope.delRecord = delRecord;
                $scope.downloadAttachment = downloadAttachment;
                $scope.addLogicAfterUploadFile = addLogicAfterUploadFile;
                $scope.simpleUploadSubmit = simpleUploadSubmit;
                $scope.coverDocFileRecord = editDocFileRecord;
                $scope.cancelDocFileType = cancelDocFileType;

            })();
        }]);
taxDocumentManageModule.directive("multiDatePicker", function () {
    return {
        restrict: "EA",
        controller: ['$scope', '$element', '$translate','$compile',
            function ($scope, $element, $translate,$compile) {

                var minDate = [1, 1970];
                var maxDate = [12, new Date().getFullYear()];
                var setDate = [
                    [1, 2018],
                    [12, 2018]
                ];

                var monthList = [$translate.instant('Month01'),
                    $translate.instant('Month02'),
                    $translate.instant('Month03'),
                    $translate.instant('Month04'),
                    $translate.instant('Month05'),
                    $translate.instant('Month06'),
                    $translate.instant('Month07'),
                    $translate.instant('Month08'),
                    $translate.instant('Month09'),
                    $translate.instant('Month10'),
                    $translate.instant('Month11'),
                    $translate.instant('Month12')
                ];

                var setModel = {
                    minDate: minDate,
                    maxDate: maxDate,
                    // setDate: setDate,
                    months: monthList,
                    RTL: "bottom left",
                    ConfirmBtnText: $translate.instant('Confirm'),
                    CancelBtnText: $translate.instant('ButtonCancel')
                };

                $('#period-picker1').rangePicker(setModel)
                    .on('datePicker.done', function (e, result) {
                        // $scope.queryFieldModel.AvailabilityDate
                        $scope.queryFieldModel.fileBeginTime = dateFormat(result[0].reverse());
                        $scope.queryFieldModel.fileEndTTime = dateFormat(result[1].reverse());
                    });
                $('#period-picker2').rangePicker(setModel)
                    .on('datePicker.done', function (e, result) {
                        // queryFieldModel.Duration
                        $scope.queryFieldModel.ownBeginTime = dateFormat(result[0].reverse());
                        $scope.queryFieldModel.ownEndTime = dateFormat(result[1].reverse());
                    });
                $('#period-picker3').rangePicker(setModel)
                    .on('datePicker.done', function (e, result) {
                        //  queryFieldModel.DueDate
                        $scope.queryFieldModel.effectiveBeginTime = dateFormat(result[0].reverse());
                        $scope.queryFieldModel.effectiveEndTime = dateFormat(result[1].reverse());
                    });
                $('#period-picker4').rangePicker(setModel)
                    .on('datePicker.done', function (e, result) {
                        // queryFieldModel.UploadDate
                        $scope.queryFieldModel.uploadBeginTime = dateFormat(result[0].reverse());
                        $scope.queryFieldModel.uploadEndTime = dateFormat(result[1].reverse());
                    });
                function dateFormat(dateArr){
                    var result = [];
                    dateArr.forEach(function(dateItem){
                        dateItem = dateItem + "";
                        dateItem = dateItem.length < 2 ? "0" + dateItem : dateItem;
                        result.push(dateItem);
                    });
                    //默认填充每月的1号
                    result.push("01");
                    return result.join("-");
                }
            }]
    }

});
taxDocumentManageModule.directive('dateTimePicker', function () {
    return {
        restrict: 'EA',
        replace: true,
        controller: ['$scope', '$element', '$attrs', 'region', function ($scope, $element, $attrs, region) {

            // 鼠标down的时候动态创建
            var year = new Date().getFullYear();
            $element.off('mousedown').on('mousedown',function(e){
                $element.datepicker({
                    startDate:new Date(year - 20, 1, 1),
                    endDate:new Date(year + 20, 1, 1),
                    minViewMode: 1,
                    autoclose: true,
                    language: region,
                    format: "yyyy-mm-dd",
                    clearBtn: true //清除按钮
                }).off("changeDate").on('changeDate', function(ev){
                    runCallback(ev);
                }).off("hide").on("hide",function(){
                    killPlugin();
                })
            });

            function resetValue(){
                $element.val("");
            }

            function killPlugin(){
                // 当选择完毕的时候，就摧毁控件，腾出内存
                $element.datepicker('remove');
            }

            function runCallback(ev){
                // changeDate的操作主要是为了，视图上被合并单元格之后，数据需要同步到被合并的单元格上
                // 这样做需要满足两个接口：
                // @rowName : 当行的数据模型的名字，
                // @itemIndex : 当前数据模型在行数据模型中的下标，
                // @callback : 回调，返回两个值，一个是选择的日期，一个是当前单元格的数据模型
                var saafTable = $scope[$attrs["table"]];
                var callback = saafTable ? saafTable.getData : $scope[$attrs["callback"]];
                var peerRow = $scope[$attrs["rowName"]];
                var itemIndex = $attrs["itemIndex"];
                if(callback) callback(ev.currentTarget.value,peerRow[itemIndex]);
            }

            function setDateRang(){
                // 当启动焦点事件的时候，才判断设置时间范围
                $element.datepicker("setStartDate", $attrs.startdate? $attrs.startdate : new Date(year - 20, 1, 1));
                $element.datepicker("setEndDate", $attrs.enddate? $attrs.enddate : new Date(year + 20, 1, 1));
            }

            function getLayout(e){
                var result = "bottom-left";
                var $ = angular.element;
                var target = $(e.currentTarget);
                var targetTop = target.offset().top;

                var targetHeight = target.height();

                var winHeight = document.body.clientHeight;

                // 300为插件的默认高度（固定值）
                // 取固定值是因为，【设置显示位置】的API只能在创建时使用
                if(targetTop + 300 + targetHeight > winHeight){
                    result = "top-left";
                }

                return result;
            }

        }]
    }
});
taxDocumentManageModule.directive('fileUploader',function () {
    return{
        restrict:"EA",
        controller:['$scope','FileUploader','apiInterceptor','taxDocumentListService','$translate','SweetAlert',
            function($scope,FileUploader,apiInterceptor,taxDocumentListService,$translate,SweetAlert){
                $scope.uploadFile = function(){
                    $("#uploadFilePlugin").click();
                };
                $scope.uploader = new FileUploader({
                    url: apiInterceptor.webApiHostUrl + "/taxDoc/add",
                    // autoUpload: true,//添加后，自动上传
                    headers:{
                        'Access-Control-Allow-Origin': '*',
                        Authorization: apiInterceptor.tokenType + ' ' + apiInterceptor.apiToken(),
                        withCredentials: true
                    },
                    removeAfterUpload:true,
                });
                $scope.uploader.filters.push({//xls限制
                    name: 'fileTypeFilter',
                    fn: function (item, options) {
                        var fileNativePath = $("#uploadFilePlugin")[0].value;
                        var splitMark = /\//.test(fileNativePath) ? "/" : "\\";
                        var prevPath = fileNativePath.split(splitMark);
                        prevPath.pop();
                        fileNativePath = prevPath.join(splitMark) + splitMark;
                        $scope.uploader.clearQueue();
                        $scope.editFieldModel.fileNativePath = fileNativePath;
                        $scope.editFieldModel.fileName = item.name;
                        return true;
                    }
                });
                $scope.uploader.onAfterAddingFile(function(item){
                    console.info("is added!",item);
                });
                $scope.uploader.onErrorItem = function(fileItem, response, status, headers) {
                    SweetAlert.warning($translate.instant('FailUpload'));
                    // $scope.uploader.cancelItem();
                    // $scope.uploader.clearQueue();
                    $scope.editFieldModel = {};

                    // $('#busy-indicator-container').hide();
                };
                // $scope.uploader.onCancelItem = function(fileItem, response, status, headers) {
                //     console.info('onCancelItem', fileItem, response, status, headers);
                // };
                $scope.uploader.onSuccessItem = function(fileItem, response, status, headers) {

                    // fileItem.filePositionUrl = response;
                    // $scope.editFieldModel.filePositionUrl = response;
                    var title = $translate.instant("Uploaded");
                    if($scope.isCoverOperation) {
                        title = $translate.instant("Edited");
                        // $scope.coverDocFileRecord($scope.editFieldModel, 'simple');
                    } else {
                        title = $translate.instant("Uploaded");
                        // $scope.addLogicAfterUploadFile($scope.editFieldModel, 'simple');
                    }

                    SweetAlert.swal({
                            title:title,
                            type: "success",
                            confirmButtonText: $translate.instant('Confirm'),
                            closeOnConfirm: true
                        },
                        function (isConfirm) {
                            if(isConfirm) $scope.loadMainData();
                        });

                    $('#simpleUploadPopDialog').modal('hide');
                };
            }]
    }
});
taxDocumentManageModule.directive('multiFileUploader',function () {
    return{
        restrict:"EA",
        controller:['$scope','FileUploader','apiInterceptor','taxDocumentListService','$translate','SweetAlert',
            function($scope,FileUploader,apiInterceptor,taxDocumentListService,$translate,SweetAlert){
                var timer = null;
                $scope.activeTab = function(activeIndex){
                    $scope.editFieldModel_multi.forEach(function (item) {
                        item.iShow = false;
                    });
                    $scope.editFieldModel_multi[activeIndex].iShow = true;
                };

                $scope.openMultiUploadPop = function(){
                    timer = null;
                    $("#multiUploadFilePlugin").click();
                    $scope.multiUploader.clearQueue();
                    $scope.editFieldModel_multi.length = 0;
                    timer = setInterval(function(){
                        if($scope.multiUploader.queue && $scope.multiUploader.queue.length > 0){
                            $("#multiUploadPopDialog").modal("show");
                            console.log("is run times");
                        }
                    },500);
                };

                // 由于$watch无法监听$scope.multiUploader，暂时用循环来做
                setInterval(function(){
                    if($("#multiUploadPopDialog").is(":visible")){
                        clearInterval(timer);
                    }
                },500);

                $scope.multiUploader = new FileUploader({
                    // autoUpload: true,//添加后，自动上传
                    headers:{"Authorization":apiInterceptor.tokenType + ' ' + apiInterceptor.apiToken()},
                    removeAfterUpload:true,
                });
                $scope.multiUploader.filters.push({//xls限制
                    name: 'fileTypeFilter',
                    fn: function (item, options) {
                        var fileNativePath = $("#multiUploadFilePlugin")[0].value;
                        var splitMark = /\//.test(fileNativePath) ? "/" : "\\";
                        var prevPath = fileNativePath.split(splitMark);
                        prevPath.pop();
                        fileNativePath = prevPath.join(splitMark) + splitMark;
                        $scope.editFieldModel_multi.push({
                            fileNativePath:fileNativePath,
                            fileName:item.name,
                            iShow:$scope.editFieldModel_multi.length === 0
                        });
                        // 根据需求，改为不做类型限制
                        return true;
                    }
                });
                $scope.multiUploader.onAfterAddingFile(function(item){
                    console.info("is added!",item);
                });

                $scope.multiUploadErrorItems = [];
                $scope.multiUploader.onErrorItem = function(fileItem) {
                    $scope.multiUploadErrorItems.push(fileItem);
                    console.info('onErrorItem', fileItem);
                };
                // $scope.multiUploader.onCancelItem = function(fileItem, response, status, headers) {
                //     console.info('onCancelItem', fileItem, response, status, headers);
                // };

                $scope.multiUploadSuccessItems = [];
                $scope.multiUploader.onCompleteAll = function () {

                    $("#uploadResultPop").modal("show");

                    $('#multiUploadPopDialog').modal('hide');
                    // $scope.multiUploader.clearQueue();
                };

                $scope.multiUploader.onSuccessItem = function(fileItem,response) {
                    // fileItem.filePositionUrl = response;
                    $scope.multiUploadSuccessItems.push(fileItem);
                };

                $scope.multiUploadSubmit = function(){
                    $scope.multiUploadErrorItems = [];
                    $scope.multiUploadSuccessItems = [];

                    for(var i = 0; i < $scope.multiUploader.queue.length;i++){

                        // 先设置uploader队列里每个文件的请求参数：fileOriginalName
                        var fileItem = $scope.multiUploader.queue[i];
                        fileItem.formData = [{
                            fileOriginName:fileItem.name ? fileItem.name : fileItem._file.name
                        }];
                        var editFieldModel = $scope.editFieldModel_multi[i];
                        Object.keys(editFieldModel).forEach(function(key){
                            var fields = {};
                            if(/(ownTime|fileTime|effectiveTime)/.test(key)){
                                fields[key] = editFieldModel[key].split("-").join("/");
                            }else{
                                fields[key] = editFieldModel[key];
                            }
                            fileItem.formData.push(fields);
                        });


                        (function(_i,_fileItem,_editFieldModel,_taxDocumentListService,_multiUploader){
                            _taxDocumentListService.verifyDuplicate(_editFieldModel).then(function(data){
                                if (data === true) {
                                    _fileItem.url = apiInterceptor.webApiHostUrl + "/taxDoc/add";
                                } else {
                                    _fileItem.url = apiInterceptor.webApiHostUrl + "/taxDoc/edit";
                                }
                                _multiUploader.uploadItem(_i);
                            });
                        })(i,fileItem,editFieldModel,taxDocumentListService,$scope.multiUploader);

                    }
                };

                $scope.confirmUploadResult = function(){
                    $('#uploadResultPop').modal('hide');
                    $scope.loadMainData();
                };
            }]
    }
});
taxDocumentManageModule.directive('filePreview',function(){
    return{
        restrict:'EA',
        controller:['$scope','$translate','SweetAlert','$compile','taxDocumentListService',function($scope,$translate,SweetAlert,$compile,taxDocumentListService){

            $scope.previewData = [];
            /**上传时预览的功能取消 2019/3/8*/
            /* $scope.viewNativeFile = function(fileItem){

                 if(!fileItem) return SweetAlert.warning($translate.instant('NeedLoadUp'));

                 var fileType = fileItem.filePositionUrl.split(".").pop();

                 if(/xlsx|xls/i.test(fileType)){
                     var reader = new FileReader();
                     reader.onload = function (e) {
                         /!* read workbook *!/
                         var wb = window.XLSX.read(e.target.result, {type:"binary"});
                         var data = window.XLSX.utils.sheet_to_json(wb.Sheets[wb.SheetNames[0]]);
                         if(data.length){
                             $scope.filePreview_dataGridUpdate(data);
                             $("#filePreviewPop").modal("show");
                         }
                         else{
                             SweetAlert.warning($translate.instant('UnReadFile'));
                         }
                         /!* DO SOMETHING WITH workbook HERE *!/
                     };

                     reader.readAsBinaryString(fileItem._file);
                 }else if(/pdf/i.test(fileType)){
                     $scope.openPdfPreviewPop(fileItem.filePositionUrl);
                 }else{
                     SweetAlert.warning($translate.instant('UnFile'));
                 }
             };*/
            $scope.currentSheetName = '';
            var sheetCurPageIndex = 0;
            var sheetSumPages = 1;
            var sheetPromise = null;
            var cacheUrl = null;

            $scope.prevPaging_xls = function(){
                if(sheetCurPageIndex <= 0) return sheetCurPageIndex = 0;
                sheetCurPageIndex --;
                sheetPromise.then(function(resData){renderXLS(resData)})
            };
            $scope.nextPaging_xls = function(){
                if(sheetCurPageIndex >= (sheetSumPages - 1)) return sheetCurPageIndex = sheetSumPages - 1;
                sheetCurPageIndex ++;
                sheetPromise.then(function(resData){renderXLS(resData)})
            };

            function getXLS(url){
                // return taxDocumentListService.getBinaryData('./bundles/MS Function list - Phase 1.xlsx');
                return taxDocumentListService.getBinaryData(url);
            }

            function renderXLS(resData){
                try{

                    var wb = window.XLSX.read(resData, {type:"array"});

                    sheetSumPages = wb.SheetNames.length;
                    $scope.currentSheetName = wb.SheetNames[sheetCurPageIndex];
                    var data = window.XLSX.utils.sheet_to_json(wb.Sheets[$scope.currentSheetName]);
                    // console.log(data);
                    if(data && data.length){
                        $scope.filePreview_dataGridUpdate(data);
                        $("#filePreviewPop").modal("show");
                    }
                }catch(e){
                    SweetAlert.warning(e.message);
                }
            }
            $scope.viewRemoteFile = function (fileName, filePositionUrl) {
                if(typeof filePositionUrl !== 'string'
                    || filePositionUrl === 'null'
                    || filePositionUrl === 'undefined')
                    return SweetAlert.warning($translate.instant('UnRecord'));

                //区分文件类型
                var fileType = fileName.split(".").pop();
                if(/xlsx|xls/i.test(fileType)){

                    if(cacheUrl !== filePositionUrl){
                        cacheUrl = filePositionUrl;
                        sheetPromise = getXLS(filePositionUrl);
                    }
                    sheetPromise.then(function(resData){renderXLS(resData)})
                }
                else if(/pdf/i.test(fileType)){
                    // return SweetAlert.warning('暂时不支持PDF预览');
                    $scope.openPdfPreviewPop(filePositionUrl);
                }else{
                    SweetAlert.warning($translate.instant('UnFile'));
                }

            };

            $scope.filePreview_dataGridUpdate = function (_data) {
                // console.info("excel:",_data);
                $scope.previewData = _data || [{}];
                var field_keys = Object.keys(_data[0]);
                var field_values = Object.values(_data[0]);

                _data.forEach(function(item){
                    var curRow_keys = Object.keys(item);
                    var curRow_values = Object.values(item);
                    if(curRow_keys && curRow_keys.length > field_keys.length){
                        field_keys = curRow_keys;
                        field_values = curRow_values;
                    }
                });

                $scope.filePreview_dataGridOptions = {
                    bindingOptions:{
                        dataSource: 'previewData',
                    },
                    showBorders: true,
                    paging: {
                        enable: true,
                        pageIndex: 1,
                        pageSize: 10
                    },
                    pager: {
                        allowedPageSizes: 5,
                        infoText: "当前 {0}页 /共 {1}页 ({2} 项)",
                        showInfo: true,
                        showNavigationButtons: true,
                        showPageSizeSelector: true,
                        visible: true
                    },
                    searchPanel: {//查询
                        highlightCaseSensitive: true,
                        highlightSearchText: true,
                        searchVisibleColumnsOnly: false,
                        text: "",
                        width: 518,
                        visible: true,
                        placeholder: $translate.instant('Search'),
                    },
                    sorting: {//排序
                        ascendingText: "Sort Ascending",
                        clearText: "Clear Sorting",
                        descendingText: "Sort Descending",
                        mode: "single"
                    },
                    showRowLines: true,
                    columnAutoWidth: true,
                    allowColumnReordering: true,
                    columns: (function(){
                        var cols = [];
                        field_keys.forEach(function(field,index){
                            cols.push({
                                dataField: field,
                                caption: (Object.keys(_data[0]).length === field_values.length) ? field_values[index]:index
                            });
                        });
                        return cols;
                    })(),
                    rowAlternationEnabled: true,  //单双行颜色
                };
                var dataGrid = $('<div dx-data-grid="filePreview_dataGridOptions">');
                $("#preview_dataGrid").html("").append(dataGrid);
                $compile(dataGrid)($scope);

            };

            $scope.hideFilePreviewPop = function(){
                $("#preview_dataGrid").html("");
                $("#filePreviewPop").modal("hide");
            };

            $scope.resetDataForm = function(){
                $scope.previewData.length = 0;
                if($scope.filePreview_dataGridOptions)
                    $scope.filePreview_dataGridOptions.columns.length = 0;
            };


        }]
    }
});
taxDocumentManageModule.directive('pdfPreview',function(){
    return{
        restrict:'EA',
        controller:['$scope',function($scope){
            window.PDFJS.workerSrc = './bundles/pdf.worker.js';
            var canvas = document.getElementById('the-canvas');
            var context = canvas.getContext('2d');
            var pdfCurPageIndex = 1;
            var pdfSumPages = 1;
            var container = document.getElementById("pdfLayoutDialog");
            var pdfPromise = null;
            var cacheUrl = null;
            $scope.openPdfPreviewPop = function(url){
                container.style.display = "block";
                if(cacheUrl !== url){
                    cacheUrl = url;
                    pdfPromise = getPdf(url);
                }
                pdfPromise.then(function(pdf){renderPdf(pdf)})
            };

            $scope.closePdfPop = function () {
                container.style.display = "none";
            };
            $scope.prevPaging = function(){
                if(pdfCurPageIndex <= 1) return pdfCurPageIndex = 1;
                pdfCurPageIndex --;
                pdfPromise.then(function(pdf){renderPdf(pdf)})
            };
            $scope.nextPaging = function(){
                if(pdfCurPageIndex >= pdfSumPages) return pdfCurPageIndex = pdfSumPages;
                pdfCurPageIndex ++;
                pdfPromise.then(function(pdf){renderPdf(pdf)})
            };
            function getPdf(url){
                // var url = 'http://47.94.233.173:11007/static/erp_tax_system/61063D1D-8C9E-47C1-B106-AFF696CF5D98?expire=1552466477&signiture=5IaoVIHX_pzmQgyaxdzYC2NsNOz_R0eyRUhQU1BJjiE=';
                return window.PDFJS.getDocument(url);
            }
            function renderPdf(pdf){
                pdfSumPages = pdf.numPages;
                pdf.getPage(pdfCurPageIndex).then(function getPageHelloWorld(page) {

                    var scale = 1.5;
                    var viewport = page.getViewport(scale);

                    //
                    // Prepare canvas using PDF page dimensions
                    //
                    canvas.height = viewport.height;
                    canvas.width = viewport.width;

                    //
                    // Render PDF page into canvas context
                    //
                    var renderContext = {
                        canvasContext: context,
                        viewport: viewport
                    };
                    page.render(renderContext);
                });
            }

        }]
    }

});
taxDocumentManageModule.directive('helpPop',function(){
    return{
        restrict:'EA',
        controller:['$scope','taxDocumentListService','$translate','$compile',
            function($scope,taxDocumentListService,$translate,$compile){
                $scope.openHelpPop = function(){
                    $scope.help_loadData();
                };
                $scope.help_cacheData = {};
                $scope.help_loadData = function () {
                    taxDocumentListService.getDocumentsAttrAndType({params:{}}).then(function (data) {
                        $scope.help_dataGridUpdate(data);
                        var dataGrid = $('<div dx-data-grid="help_dataGridOptions">');
                        $("#helpPopContainer").html("").append(dataGrid);
                        $compile(dataGrid)($scope);
                        $("#helpPopDialog").modal("show");
                    })
                };
                $scope.help_dataGridUpdate = function (_data) {
                    $scope.help_cacheData = _data.items;
                    $scope.help_dataGridOptions = {
                        bindingOptions: {
                            dataSource: 'help_cacheData',
                        },
                        paging: {
                            enable: true,
                            pageIndex: 0,
                            pageSize: 10
                        },
                        pager: {
                            allowedPageSizes: 5,
                            infoText: "当前 {0}页 /共 {1}页 ({2} 项)",
                            showInfo: true,
                            showNavigationButtons: true,
                            showPageSizeSelector: true,
                            visible: true
                        },
                        showBorders: true,
                        showRowLines: true,
                        columnAutoWidth: true,
                        allowColumnReordering: true,
                        columns: [
                            {
                                dataField: "fileAttr",
                                caption: $translate.instant('DocumentAttr'),

                            },
                            {
                                dataField: "fileType",
                                caption: $translate.instant('DocumentType'),

                            },
                            {
                                dataField: "description",
                                caption: $translate.instant('Description'),

                            },

                        ],
                    };
                };

            }]
    }
});